
import os,sys
from distutils.core import setup, Extension
from distutils.sysconfig import get_python_inc,get_python_lib
import numpy

numdir = os.path.dirname(numpy.__file__)+"/core/include/numpy"
fitsinc = os.environ["PYTHONBASE"]+"/include/"
fitslib = os.environ["PYTHONBASE"]+"/lib/"

setup(name="module-cfitsio",version="2.420",
        description="Python Interface to CFITSIO",
        author="Daniel D. Kelson",
        author_email="kelson@ociw.edu",
        url="http://www.ociw.edu/~kelson",
        #scripts=["CFITSIO2.py","cfitsio.py"],
        extra_path="module-cfitsio",
        packages = [''],
        package_dir = {'': 'Lib'},
        ext_modules=[Extension("cfitsioc",
                ["fitsio_wrap.c"],
                include_dirs=[numdir,fitsinc],
                library_dirs=[fitslib],
                libraries=["cfitsio","m","c"],
                        )])

